#pragma once

#include "BaseForm.h"
using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

namespace ObjDataEdit
{
	/// <summary> 
	/// Summary for LearnMagicForm
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
#ifndef _Just_Show_DotNet_Form_
    public __gc class LearnMagicForm : public System::Windows::Forms::Form
#else 
    public __gc class LearnMagicForm : public BaseForm
#endif	
	{
	public: 
        LearnMagicForm( char* FormName , char* DBName , char* OutputFile  , bool IsReadOnly , SearchFormTypeENUM FormType ) :  BaseForm( FormName , DBName , OutputFile  , IsReadOnly , FormType )
        {
            InitializeComponent();
            this->panel4_Base->Controls->Add(this->panel1);
//            SetLabelInfo();
        }  
        
	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
    private: System::Windows::Forms::Panel *  panel1;
    private: System::Windows::Forms::Label *  label9;
    private: System::Windows::Forms::ComboBox *  CB_NpcJob;
    private: System::Windows::Forms::GroupBox *  groupBox1;
    private: System::Windows::Forms::Button *  button1;
    private: System::Windows::Forms::GroupBox *  groupBox2;
	private: System::Windows::Forms::ListView*  LV_NormalMagic;

	private: System::Windows::Forms::ColumnHeader*  columnHeader1;
	private: System::Windows::Forms::ColumnHeader*  columnHeader2;
	private: System::Windows::Forms::ColumnHeader*  columnHeader3;
	private: System::Windows::Forms::ColumnHeader*  columnHeader4;
	private: System::Windows::Forms::ColumnHeader*  columnHeader5;
	private: System::Windows::Forms::GroupBox*  groupBox3;
	private: System::Windows::Forms::TextBox*  TB_KeyItem;

	private: System::Windows::Forms::Label*  label2;
	private: System::Windows::Forms::Label*  LB_MagicName;


	private: System::Windows::Forms::TextBox*  TB_MagicID;

	private: System::Windows::Forms::Label*  label1;
	private: System::Windows::Forms::Button*  button4;
	private: System::Windows::Forms::Button*  button3;
	private: System::Windows::Forms::Button*  button2;
	private: System::Windows::Forms::TextBox*  TB_RequestLV;

	private: System::Windows::Forms::Label*  label4;
	private: System::Windows::Forms::Label*  LB_KeyItemName;

	private: System::Windows::Forms::Button*  button5;
	private: System::Windows::Forms::Button*  button6;
	private: System::Windows::Forms::Button*  button7;
	private: System::Windows::Forms::GroupBox*  groupBox4;
	private: System::Windows::Forms::TextBox*  TB_SPRequestLV;

	private: System::Windows::Forms::Label*  label5;
	private: System::Windows::Forms::Label*  LB_SPKeyItemName;

	private: System::Windows::Forms::TextBox*  TB_SPKeyItem;

	private: System::Windows::Forms::Label*  label7;
	private: System::Windows::Forms::Label*  LB_SPMagicName;

	private: System::Windows::Forms::TextBox*  TB_SPMagicID;

	private: System::Windows::Forms::Label*  label10;
	private: System::Windows::Forms::ListView*  LV_SPMagic;

	private: System::Windows::Forms::ColumnHeader*  columnHeader6;
	private: System::Windows::Forms::ColumnHeader*  columnHeader7;
	private: System::Windows::Forms::ColumnHeader*  columnHeader8;
	private: System::Windows::Forms::ColumnHeader*  columnHeader9;
	private: System::Windows::Forms::ColumnHeader*  columnHeader10;
	private: System::Windows::Forms::Button*  button9;
	private: System::Windows::Forms::Button*  button8;
	private: System::Windows::Forms::Button*  button10;
	private: System::Windows::Forms::Button*  button11;
	private: System::Windows::Forms::Button*  button12;
	private: System::Windows::Forms::TabControl*  tabControl1;
	private: System::Windows::Forms::TabPage*  tabPage1;
	private: System::Windows::Forms::TabPage*  tabPage2;
	private: System::Windows::Forms::ColumnHeader*  columnHeader11;
	private: System::Windows::Forms::ColumnHeader*  columnHeader12;
	private: System::Windows::Forms::ColumnHeader*  columnHeader13;
	private: System::Windows::Forms::ColumnHeader*  columnHeader14;
	private: System::Windows::Forms::Label*  LB_NormalNeedMagicID1;

	private: System::Windows::Forms::TextBox*  TB_NormalNeedMagicID1;



	private: System::Windows::Forms::Label*  label6;
	private: System::Windows::Forms::TextBox*  TB_NormalNeedMagicLv2;

	private: System::Windows::Forms::Label*  label11;
	private: System::Windows::Forms::Label*  LB_NormalNeedMagicID2;

	private: System::Windows::Forms::TextBox*  TB_NormalNeedMagicID2;




	private: System::Windows::Forms::Label*  label13;
private: System::Windows::Forms::TextBox*  TB_NormalNeedMagicLv1;

	private: System::Windows::Forms::Label*  label8;
private: System::Windows::Forms::TextBox*  TB_SPNeedMagicLv2;

	private: System::Windows::Forms::Label*  label14;
private: System::Windows::Forms::Label*  LB_SPNeedMagicID2;

private: System::Windows::Forms::TextBox*  TB_SPNeedMagicID2;

	private: System::Windows::Forms::Label*  label16;
private: System::Windows::Forms::TextBox*  TB_SPNeedMagicLv1;

	private: System::Windows::Forms::Label*  label17;
private: System::Windows::Forms::Label*  LB_SPNeedMagicID1;

private: System::Windows::Forms::TextBox*  TB_SPNeedMagicID1;


	private: System::Windows::Forms::Label*  label19;
	private: System::Windows::Forms::ColumnHeader*  columnHeader15;
	private: System::Windows::Forms::ColumnHeader*  columnHeader16;
	private: System::Windows::Forms::ColumnHeader*  columnHeader17;
	private: System::Windows::Forms::ColumnHeader*  columnHeader18;
private: System::Windows::Forms::ColumnHeader*  columnHeader19;
private: System::Windows::Forms::ColumnHeader*  columnHeader20;
private: System::Windows::Forms::ColumnHeader*  columnHeader21;
private: System::Windows::Forms::ColumnHeader*  columnHeader22;



private: System::Windows::Forms::TextBox*  TB_Pos;

private: System::Windows::Forms::Label*  label12;
private: System::Windows::Forms::ColumnHeader*  columnHeader23;




private: System::Windows::Forms::TextBox*  TB_SPPos;

private: System::Windows::Forms::Label*  label18;
private: System::Windows::Forms::ColumnHeader*  columnHeader25;




	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container* components;

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->panel1 = (new System::Windows::Forms::Panel());
			this->tabControl1 = (new System::Windows::Forms::TabControl());
			this->tabPage1 = (new System::Windows::Forms::TabPage());
			this->groupBox1 = (new System::Windows::Forms::GroupBox());
			this->button9 = (new System::Windows::Forms::Button());
			this->button8 = (new System::Windows::Forms::Button());
			this->button4 = (new System::Windows::Forms::Button());
			this->button3 = (new System::Windows::Forms::Button());
			this->button2 = (new System::Windows::Forms::Button());
			this->groupBox3 = (new System::Windows::Forms::GroupBox());
			this->TB_Pos = (new System::Windows::Forms::TextBox());
			this->label12 = (new System::Windows::Forms::Label());
			this->TB_NormalNeedMagicLv2 = (new System::Windows::Forms::TextBox());
			this->label11 = (new System::Windows::Forms::Label());
			this->LB_NormalNeedMagicID2 = (new System::Windows::Forms::Label());
			this->TB_NormalNeedMagicID2 = (new System::Windows::Forms::TextBox());
			this->label13 = (new System::Windows::Forms::Label());
			this->TB_NormalNeedMagicLv1 = (new System::Windows::Forms::TextBox());
			this->label8 = (new System::Windows::Forms::Label());
			this->LB_NormalNeedMagicID1 = (new System::Windows::Forms::Label());
			this->TB_NormalNeedMagicID1 = (new System::Windows::Forms::TextBox());
			this->label6 = (new System::Windows::Forms::Label());
			this->TB_RequestLV = (new System::Windows::Forms::TextBox());
			this->label4 = (new System::Windows::Forms::Label());
			this->LB_KeyItemName = (new System::Windows::Forms::Label());
			this->TB_KeyItem = (new System::Windows::Forms::TextBox());
			this->label2 = (new System::Windows::Forms::Label());
			this->LB_MagicName = (new System::Windows::Forms::Label());
			this->TB_MagicID = (new System::Windows::Forms::TextBox());
			this->label1 = (new System::Windows::Forms::Label());
			this->LV_NormalMagic = (new System::Windows::Forms::ListView());
			this->columnHeader23 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader1 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader2 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader3 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader4 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader5 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader11 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader19 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader12 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader13 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader20 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader14 = (new System::Windows::Forms::ColumnHeader());
			this->tabPage2 = (new System::Windows::Forms::TabPage());
			this->groupBox2 = (new System::Windows::Forms::GroupBox());
			this->button10 = (new System::Windows::Forms::Button());
			this->button11 = (new System::Windows::Forms::Button());
			this->button5 = (new System::Windows::Forms::Button());
			this->button6 = (new System::Windows::Forms::Button());
			this->button7 = (new System::Windows::Forms::Button());
			this->groupBox4 = (new System::Windows::Forms::GroupBox());
			this->TB_SPPos = (new System::Windows::Forms::TextBox());
			this->label18 = (new System::Windows::Forms::Label());
			this->TB_SPNeedMagicLv2 = (new System::Windows::Forms::TextBox());
			this->label14 = (new System::Windows::Forms::Label());
			this->LB_SPNeedMagicID2 = (new System::Windows::Forms::Label());
			this->TB_SPNeedMagicID2 = (new System::Windows::Forms::TextBox());
			this->label16 = (new System::Windows::Forms::Label());
			this->TB_SPNeedMagicLv1 = (new System::Windows::Forms::TextBox());
			this->label17 = (new System::Windows::Forms::Label());
			this->LB_SPNeedMagicID1 = (new System::Windows::Forms::Label());
			this->TB_SPNeedMagicID1 = (new System::Windows::Forms::TextBox());
			this->label19 = (new System::Windows::Forms::Label());
			this->TB_SPRequestLV = (new System::Windows::Forms::TextBox());
			this->label5 = (new System::Windows::Forms::Label());
			this->LB_SPKeyItemName = (new System::Windows::Forms::Label());
			this->TB_SPKeyItem = (new System::Windows::Forms::TextBox());
			this->label7 = (new System::Windows::Forms::Label());
			this->LB_SPMagicName = (new System::Windows::Forms::Label());
			this->TB_SPMagicID = (new System::Windows::Forms::TextBox());
			this->label10 = (new System::Windows::Forms::Label());
			this->LV_SPMagic = (new System::Windows::Forms::ListView());
			this->columnHeader25 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader6 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader7 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader8 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader9 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader10 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader15 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader21 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader16 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader17 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader22 = (new System::Windows::Forms::ColumnHeader());
			this->columnHeader18 = (new System::Windows::Forms::ColumnHeader());
			this->button12 = (new System::Windows::Forms::Button());
			this->label9 = (new System::Windows::Forms::Label());
			this->CB_NpcJob = (new System::Windows::Forms::ComboBox());
			this->button1 = (new System::Windows::Forms::Button());
			this->panel1->SuspendLayout();
			this->tabControl1->SuspendLayout();
			this->tabPage1->SuspendLayout();
			this->groupBox1->SuspendLayout();
			this->groupBox3->SuspendLayout();
			this->tabPage2->SuspendLayout();
			this->groupBox2->SuspendLayout();
			this->groupBox4->SuspendLayout();
			this->SuspendLayout();
			// 
			// panel1
			// 
			this->panel1->AutoScroll = true;
			this->panel1->Controls->Add(this->tabControl1);
			this->panel1->Controls->Add(this->button12);
			this->panel1->Controls->Add(this->label9);
			this->panel1->Controls->Add(this->CB_NpcJob);
			this->panel1->Controls->Add(this->button1);
			this->panel1->Dock = System::Windows::Forms::DockStyle::Fill;
			this->panel1->Location = System::Drawing::Point(0, 0);
			this->panel1->Name = S"panel1";
			this->panel1->Size = System::Drawing::Size(1040, 657);
			this->panel1->TabIndex = 28;
			// 
			// tabControl1
			// 
			this->tabControl1->Anchor = (System::Windows::Forms::AnchorStyles)(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right);
			this->tabControl1->Controls->Add(this->tabPage1);
			this->tabControl1->Controls->Add(this->tabPage2);
			this->tabControl1->Location = System::Drawing::Point(0, 49);
			this->tabControl1->Name = S"tabControl1";
			this->tabControl1->SelectedIndex = 0;
			this->tabControl1->Size = System::Drawing::Size(1040, 608);
			this->tabControl1->TabIndex = 28;
			// 
			// tabPage1
			// 
			this->tabPage1->Controls->Add(this->groupBox1);
			this->tabPage1->Location = System::Drawing::Point(4, 21);
			this->tabPage1->Name = S"tabPage1";
			this->tabPage1->Padding = System::Windows::Forms::Padding(3);
			this->tabPage1->Size = System::Drawing::Size(1032, 583);
			this->tabPage1->TabIndex = 0;
			this->tabPage1->Text = S"一般技能";
			this->tabPage1->UseVisualStyleBackColor = true;
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->button9);
			this->groupBox1->Controls->Add(this->button8);
			this->groupBox1->Controls->Add(this->button4);
			this->groupBox1->Controls->Add(this->button3);
			this->groupBox1->Controls->Add(this->button2);
			this->groupBox1->Controls->Add(this->groupBox3);
			this->groupBox1->Controls->Add(this->LV_NormalMagic);
			this->groupBox1->Dock = System::Windows::Forms::DockStyle::Fill;
			this->groupBox1->Location = System::Drawing::Point(3, 3);
			this->groupBox1->Name = S"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(1026, 577);
			this->groupBox1->TabIndex = 24;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = S"一般技能";
			// 
			// button9
			// 
			this->button9->Location = System::Drawing::Point(1005, 340);
			this->button9->Name = S"button9";
			this->button9->Size = System::Drawing::Size(15, 90);
			this->button9->TabIndex = 21;
			this->button9->Text = S"v";
			this->button9->UseVisualStyleBackColor = true;
			this->button9->Click += new System::EventHandler(this, &LearnMagicForm::NormalMagic_DownClick);
			// 
			// button8
			// 
			this->button8->Location = System::Drawing::Point(1005, 229);
			this->button8->Name = S"button8";
			this->button8->Size = System::Drawing::Size(15, 90);
			this->button8->TabIndex = 20;
			this->button8->Text = S"^";
			this->button8->UseVisualStyleBackColor = true;
			this->button8->Click += new System::EventHandler(this, &LearnMagicForm::NormalMagic_UpClick);
			// 
			// button4
			// 
			this->button4->Location = System::Drawing::Point(951, 117);
			this->button4->Name = S"button4";
			this->button4->Size = System::Drawing::Size(48, 23);
			this->button4->TabIndex = 19;
			this->button4->Text = S"刪除";
			this->button4->UseVisualStyleBackColor = true;
			this->button4->Click += new System::EventHandler(this, &LearnMagicForm::DelNormalMagic_Click);
			// 
			// button3
			// 
			this->button3->Location = System::Drawing::Point(897, 117);
			this->button3->Name = S"button3";
			this->button3->Size = System::Drawing::Size(48, 23);
			this->button3->TabIndex = 18;
			this->button3->Text = S"新增";
			this->button3->UseVisualStyleBackColor = true;
			this->button3->Click += new System::EventHandler(this, &LearnMagicForm::NewNormalMagic_Click);
			// 
			// button2
			// 
			this->button2->Location = System::Drawing::Point(24, 117);
			this->button2->Name = S"button2";
			this->button2->Size = System::Drawing::Size(48, 23);
			this->button2->TabIndex = 17;
			this->button2->Text = S"修改";
			this->button2->UseVisualStyleBackColor = true;
			this->button2->Click += new System::EventHandler(this, &LearnMagicForm::ModifyNormalMagic_Click);
			// 
			// groupBox3
			// 
			this->groupBox3->Controls->Add(this->TB_Pos);
			this->groupBox3->Controls->Add(this->label12);
			this->groupBox3->Controls->Add(this->TB_NormalNeedMagicLv2);
			this->groupBox3->Controls->Add(this->label11);
			this->groupBox3->Controls->Add(this->LB_NormalNeedMagicID2);
			this->groupBox3->Controls->Add(this->TB_NormalNeedMagicID2);
			this->groupBox3->Controls->Add(this->label13);
			this->groupBox3->Controls->Add(this->TB_NormalNeedMagicLv1);
			this->groupBox3->Controls->Add(this->label8);
			this->groupBox3->Controls->Add(this->LB_NormalNeedMagicID1);
			this->groupBox3->Controls->Add(this->TB_NormalNeedMagicID1);
			this->groupBox3->Controls->Add(this->label6);
			this->groupBox3->Controls->Add(this->TB_RequestLV);
			this->groupBox3->Controls->Add(this->label4);
			this->groupBox3->Controls->Add(this->LB_KeyItemName);
			this->groupBox3->Controls->Add(this->TB_KeyItem);
			this->groupBox3->Controls->Add(this->label2);
			this->groupBox3->Controls->Add(this->LB_MagicName);
			this->groupBox3->Controls->Add(this->TB_MagicID);
			this->groupBox3->Controls->Add(this->label1);
			this->groupBox3->Location = System::Drawing::Point(12, 16);
			this->groupBox3->Name = S"groupBox3";
			this->groupBox3->Size = System::Drawing::Size(987, 95);
			this->groupBox3->TabIndex = 16;
			this->groupBox3->TabStop = false;
			this->groupBox3->Text = S"資料編輯";
			// 
			// TB_Pos
			// 
			this->TB_Pos->Location = System::Drawing::Point(45, 21);
			this->TB_Pos->Name = S"TB_Pos";
			this->TB_Pos->Size = System::Drawing::Size(39, 22);
			this->TB_Pos->TabIndex = 22;
			// 
			// label12
			// 
			this->label12->AutoSize = true;
			this->label12->Location = System::Drawing::Point(10, 24);
			this->label12->Name = S"label12";
			this->label12->Size = System::Drawing::Size(29, 12);
			this->label12->TabIndex = 21;
			this->label12->Text = S"位置";
			// 
			// TB_NormalNeedMagicLv2
			// 
			this->TB_NormalNeedMagicLv2->Location = System::Drawing::Point(809, 52);
			this->TB_NormalNeedMagicLv2->Name = S"TB_NormalNeedMagicLv2";
			this->TB_NormalNeedMagicLv2->Size = System::Drawing::Size(39, 22);
			this->TB_NormalNeedMagicLv2->TabIndex = 20;
			// 
			// label11
			// 
			this->label11->AutoSize = true;
			this->label11->Location = System::Drawing::Point(732, 55);
			this->label11->Name = S"label11";
			this->label11->Size = System::Drawing::Size(77, 12);
			this->label11->TabIndex = 19;
			this->label11->Text = S"需求法術等級";
			// 
			// LB_NormalNeedMagicID2
			// 
			this->LB_NormalNeedMagicID2->AutoSize = true;
			this->LB_NormalNeedMagicID2->Location = System::Drawing::Point(634, 55);
			this->LB_NormalNeedMagicID2->Name = S"LB_NormalNeedMagicID2";
			this->LB_NormalNeedMagicID2->Size = System::Drawing::Size(29, 12);
			this->LB_NormalNeedMagicID2->TabIndex = 18;
			this->LB_NormalNeedMagicID2->Text = S"名稱";
			// 
			// TB_NormalNeedMagicID2
			// 
			this->TB_NormalNeedMagicID2->Location = System::Drawing::Point(568, 52);
			this->TB_NormalNeedMagicID2->Name = S"TB_NormalNeedMagicID2";
			this->TB_NormalNeedMagicID2->Size = System::Drawing::Size(60, 22);
			this->TB_NormalNeedMagicID2->TabIndex = 17;
			this->TB_NormalNeedMagicID2->DoubleClick += new System::EventHandler(this, &LearnMagicForm::SearchMagicClick);
			this->TB_NormalNeedMagicID2->TextChanged += new System::EventHandler(this, &LearnMagicForm::OnMagicInfoChange);
			// 
			// label13
			// 
			this->label13->AutoSize = true;
			this->label13->Location = System::Drawing::Point(496, 55);
			this->label13->Name = S"label13";
			this->label13->Size = System::Drawing::Size(65, 12);
			this->label13->TabIndex = 16;
			this->label13->Text = S"需求法術ID";
			// 
			// TB_NormalNeedMagicLv1
			// 
			this->TB_NormalNeedMagicLv1->Location = System::Drawing::Point(809, 21);
			this->TB_NormalNeedMagicLv1->Name = S"TB_NormalNeedMagicLv1";
			this->TB_NormalNeedMagicLv1->Size = System::Drawing::Size(39, 22);
			this->TB_NormalNeedMagicLv1->TabIndex = 15;
			// 
			// label8
			// 
			this->label8->AutoSize = true;
			this->label8->Location = System::Drawing::Point(732, 24);
			this->label8->Name = S"label8";
			this->label8->Size = System::Drawing::Size(77, 12);
			this->label8->TabIndex = 14;
			this->label8->Text = S"需求法術等級";
			// 
			// LB_NormalNeedMagicID1
			// 
			this->LB_NormalNeedMagicID1->AutoSize = true;
			this->LB_NormalNeedMagicID1->Location = System::Drawing::Point(634, 24);
			this->LB_NormalNeedMagicID1->Name = S"LB_NormalNeedMagicID1";
			this->LB_NormalNeedMagicID1->Size = System::Drawing::Size(29, 12);
			this->LB_NormalNeedMagicID1->TabIndex = 13;
			this->LB_NormalNeedMagicID1->Text = S"名稱";
			// 
			// TB_NormalNeedMagicID1
			// 
			this->TB_NormalNeedMagicID1->Location = System::Drawing::Point(568, 21);
			this->TB_NormalNeedMagicID1->Name = S"TB_NormalNeedMagicID1";
			this->TB_NormalNeedMagicID1->Size = System::Drawing::Size(60, 22);
			this->TB_NormalNeedMagicID1->TabIndex = 12;
			this->TB_NormalNeedMagicID1->DoubleClick += new System::EventHandler(this, &LearnMagicForm::SearchMagicClick);
			this->TB_NormalNeedMagicID1->TextChanged += new System::EventHandler(this, &LearnMagicForm::OnMagicInfoChange);
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->Location = System::Drawing::Point(496, 24);
			this->label6->Name = S"label6";
			this->label6->Size = System::Drawing::Size(65, 12);
			this->label6->TabIndex = 11;
			this->label6->Text = S"需求法術ID";
			// 
			// TB_RequestLV
			// 
			this->TB_RequestLV->Location = System::Drawing::Point(411, 21);
			this->TB_RequestLV->Name = S"TB_RequestLV";
			this->TB_RequestLV->Size = System::Drawing::Size(39, 22);
			this->TB_RequestLV->TabIndex = 10;
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Location = System::Drawing::Point(354, 24);
			this->label4->Name = S"label4";
			this->label4->Size = System::Drawing::Size(53, 12);
			this->label4->TabIndex = 9;
			this->label4->Text = S"需求等級";
			// 
			// LB_KeyItemName
			// 
			this->LB_KeyItemName->AutoSize = true;
			this->LB_KeyItemName->Location = System::Drawing::Point(239, 52);
			this->LB_KeyItemName->Name = S"LB_KeyItemName";
			this->LB_KeyItemName->Size = System::Drawing::Size(29, 12);
			this->LB_KeyItemName->TabIndex = 8;
			this->LB_KeyItemName->Text = S"名稱";
			// 
			// TB_KeyItem
			// 
			this->TB_KeyItem->Location = System::Drawing::Point(173, 49);
			this->TB_KeyItem->Name = S"TB_KeyItem";
			this->TB_KeyItem->Size = System::Drawing::Size(60, 22);
			this->TB_KeyItem->TabIndex = 7;
			this->TB_KeyItem->DoubleClick += new System::EventHandler(this, &LearnMagicForm::SearchKeyItemClick);
			this->TB_KeyItem->TextChanged += new System::EventHandler(this, &LearnMagicForm::OnMagicInfoChange);
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(114, 52);
			this->label2->Name = S"label2";
			this->label2->Size = System::Drawing::Size(53, 12);
			this->label2->TabIndex = 6;
			this->label2->Text = S"重要物品";
			// 
			// LB_MagicName
			// 
			this->LB_MagicName->AutoSize = true;
			this->LB_MagicName->Location = System::Drawing::Point(239, 24);
			this->LB_MagicName->Name = S"LB_MagicName";
			this->LB_MagicName->Size = System::Drawing::Size(29, 12);
			this->LB_MagicName->TabIndex = 5;
			this->LB_MagicName->Text = S"名稱";
			// 
			// TB_MagicID
			// 
			this->TB_MagicID->Location = System::Drawing::Point(173, 21);
			this->TB_MagicID->Name = S"TB_MagicID";
			this->TB_MagicID->Size = System::Drawing::Size(60, 22);
			this->TB_MagicID->TabIndex = 4;
			this->TB_MagicID->DoubleClick += new System::EventHandler(this, &LearnMagicForm::SearchMagicClick);
			this->TB_MagicID->TextChanged += new System::EventHandler(this, &LearnMagicForm::OnMagicInfoChange);
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(114, 24);
			this->label1->Name = S"label1";
			this->label1->Size = System::Drawing::Size(41, 12);
			this->label1->TabIndex = 3;
			this->label1->Text = S"法術ID";
			// 
			// LV_NormalMagic
			// 
			System::Windows::Forms::ColumnHeader* __mcTemp__1[] = new System::Windows::Forms::ColumnHeader*[12];
			__mcTemp__1[0] = this->columnHeader23;
			__mcTemp__1[1] = this->columnHeader1;
			__mcTemp__1[2] = this->columnHeader2;
			__mcTemp__1[3] = this->columnHeader3;
			__mcTemp__1[4] = this->columnHeader4;
			__mcTemp__1[5] = this->columnHeader5;
			__mcTemp__1[6] = this->columnHeader11;
			__mcTemp__1[7] = this->columnHeader19;
			__mcTemp__1[8] = this->columnHeader12;
			__mcTemp__1[9] = this->columnHeader13;
			__mcTemp__1[10] = this->columnHeader20;
			__mcTemp__1[11] = this->columnHeader14;
			this->LV_NormalMagic->Columns->AddRange(__mcTemp__1);
			this->LV_NormalMagic->FullRowSelect = true;
			this->LV_NormalMagic->GridLines = true;
			this->LV_NormalMagic->HideSelection = false;
			this->LV_NormalMagic->LabelWrap = false;
			this->LV_NormalMagic->Location = System::Drawing::Point(6, 146);
			this->LV_NormalMagic->MultiSelect = false;
			this->LV_NormalMagic->Name = S"LV_NormalMagic";
			this->LV_NormalMagic->Size = System::Drawing::Size(993, 409);
			this->LV_NormalMagic->TabIndex = 15;
			this->LV_NormalMagic->UseCompatibleStateImageBehavior = false;
			this->LV_NormalMagic->View = System::Windows::Forms::View::Details;
			this->LV_NormalMagic->SelectedIndexChanged += new System::EventHandler(this, &LearnMagicForm::LV_NormalMagic_SelectedIndexChanged);
			// 
			// columnHeader23
			// 
			this->columnHeader23->Text = S"位置";
			this->columnHeader23->Width = 42;
			// 
			// columnHeader1
			// 
			this->columnHeader1->Text = S"技能ID";
			// 
			// columnHeader2
			// 
			this->columnHeader2->Text = S"名稱";
			this->columnHeader2->Width = 100;
			// 
			// columnHeader3
			// 
			this->columnHeader3->Text = S"等級";
			this->columnHeader3->Width = 40;
			// 
			// columnHeader4
			// 
			this->columnHeader4->Text = S"重要物品ID";
			this->columnHeader4->Width = 90;
			// 
			// columnHeader5
			// 
			this->columnHeader5->Text = S"物品名稱";
			this->columnHeader5->Width = 90;
			// 
			// columnHeader11
			// 
			this->columnHeader11->Text = S"前置法術ID1";
			this->columnHeader11->Width = 85;
			// 
			// columnHeader19
			// 
			this->columnHeader19->Text = S"法術名稱";
			this->columnHeader19->Width = 85;
			// 
			// columnHeader12
			// 
			this->columnHeader12->Text = S"前置法術LV1";
			this->columnHeader12->Width = 85;
			// 
			// columnHeader13
			// 
			this->columnHeader13->Text = S"前置法術ID2";
			this->columnHeader13->Width = 85;
			// 
			// columnHeader20
			// 
			this->columnHeader20->Text = S"法術名稱";
			this->columnHeader20->Width = 85;
			// 
			// columnHeader14
			// 
			this->columnHeader14->Text = S"前置法術LV2";
			this->columnHeader14->Width = 85;
			// 
			// tabPage2
			// 
			this->tabPage2->Controls->Add(this->groupBox2);
			this->tabPage2->Location = System::Drawing::Point(4, 21);
			this->tabPage2->Name = S"tabPage2";
			this->tabPage2->Padding = System::Windows::Forms::Padding(3);
			this->tabPage2->Size = System::Drawing::Size(1032, 583);
			this->tabPage2->TabIndex = 1;
			this->tabPage2->Text = S"主職專屬";
			this->tabPage2->UseVisualStyleBackColor = true;
			// 
			// groupBox2
			// 
			this->groupBox2->Controls->Add(this->button10);
			this->groupBox2->Controls->Add(this->button11);
			this->groupBox2->Controls->Add(this->button5);
			this->groupBox2->Controls->Add(this->button6);
			this->groupBox2->Controls->Add(this->button7);
			this->groupBox2->Controls->Add(this->groupBox4);
			this->groupBox2->Controls->Add(this->LV_SPMagic);
			this->groupBox2->Dock = System::Windows::Forms::DockStyle::Fill;
			this->groupBox2->Location = System::Drawing::Point(3, 3);
			this->groupBox2->Name = S"groupBox2";
			this->groupBox2->Size = System::Drawing::Size(1026, 577);
			this->groupBox2->TabIndex = 25;
			this->groupBox2->TabStop = false;
			this->groupBox2->Text = S"職業專屬技能";
			this->groupBox2->Enter += new System::EventHandler(this, &LearnMagicForm::groupBox2_Enter);
			// 
			// button10
			// 
			this->button10->Location = System::Drawing::Point(1005, 341);
			this->button10->Name = S"button10";
			this->button10->Size = System::Drawing::Size(15, 90);
			this->button10->TabIndex = 26;
			this->button10->Text = S"v";
			this->button10->UseVisualStyleBackColor = true;
			this->button10->Click += new System::EventHandler(this, &LearnMagicForm::SPMagic_DownClick);
			// 
			// button11
			// 
			this->button11->Location = System::Drawing::Point(1005, 230);
			this->button11->Name = S"button11";
			this->button11->Size = System::Drawing::Size(15, 90);
			this->button11->TabIndex = 25;
			this->button11->Text = S"^";
			this->button11->UseVisualStyleBackColor = true;
			this->button11->Click += new System::EventHandler(this, &LearnMagicForm::SPMagic_UpClick);
			// 
			// button5
			// 
			this->button5->Location = System::Drawing::Point(951, 117);
			this->button5->Name = S"button5";
			this->button5->Size = System::Drawing::Size(48, 23);
			this->button5->TabIndex = 24;
			this->button5->Text = S"刪除";
			this->button5->UseVisualStyleBackColor = true;
			this->button5->Click += new System::EventHandler(this, &LearnMagicForm::DelSPMagic_Click);
			// 
			// button6
			// 
			this->button6->Location = System::Drawing::Point(897, 117);
			this->button6->Name = S"button6";
			this->button6->Size = System::Drawing::Size(48, 23);
			this->button6->TabIndex = 23;
			this->button6->Text = S"新增";
			this->button6->UseVisualStyleBackColor = true;
			this->button6->Click += new System::EventHandler(this, &LearnMagicForm::NewSPMagic_Click);
			// 
			// button7
			// 
			this->button7->Location = System::Drawing::Point(24, 117);
			this->button7->Name = S"button7";
			this->button7->Size = System::Drawing::Size(48, 23);
			this->button7->TabIndex = 22;
			this->button7->Text = S"修改";
			this->button7->UseVisualStyleBackColor = true;
			this->button7->Click += new System::EventHandler(this, &LearnMagicForm::ModifySPMagic_Click);
			// 
			// groupBox4
			// 
			this->groupBox4->Controls->Add(this->TB_SPPos);
			this->groupBox4->Controls->Add(this->label18);
			this->groupBox4->Controls->Add(this->TB_SPNeedMagicLv2);
			this->groupBox4->Controls->Add(this->label14);
			this->groupBox4->Controls->Add(this->LB_SPNeedMagicID2);
			this->groupBox4->Controls->Add(this->TB_SPNeedMagicID2);
			this->groupBox4->Controls->Add(this->label16);
			this->groupBox4->Controls->Add(this->TB_SPNeedMagicLv1);
			this->groupBox4->Controls->Add(this->label17);
			this->groupBox4->Controls->Add(this->LB_SPNeedMagicID1);
			this->groupBox4->Controls->Add(this->TB_SPNeedMagicID1);
			this->groupBox4->Controls->Add(this->label19);
			this->groupBox4->Controls->Add(this->TB_SPRequestLV);
			this->groupBox4->Controls->Add(this->label5);
			this->groupBox4->Controls->Add(this->LB_SPKeyItemName);
			this->groupBox4->Controls->Add(this->TB_SPKeyItem);
			this->groupBox4->Controls->Add(this->label7);
			this->groupBox4->Controls->Add(this->LB_SPMagicName);
			this->groupBox4->Controls->Add(this->TB_SPMagicID);
			this->groupBox4->Controls->Add(this->label10);
			this->groupBox4->Location = System::Drawing::Point(12, 16);
			this->groupBox4->Name = S"groupBox4";
			this->groupBox4->Size = System::Drawing::Size(987, 95);
			this->groupBox4->TabIndex = 21;
			this->groupBox4->TabStop = false;
			this->groupBox4->Text = S"資料編輯";
			// 
			// TB_SPPos
			// 
			this->TB_SPPos->Location = System::Drawing::Point(45, 21);
			this->TB_SPPos->Name = S"TB_SPPos";
			this->TB_SPPos->Size = System::Drawing::Size(39, 22);
			this->TB_SPPos->TabIndex = 32;
			// 
			// label18
			// 
			this->label18->AutoSize = true;
			this->label18->Location = System::Drawing::Point(10, 24);
			this->label18->Name = S"label18";
			this->label18->Size = System::Drawing::Size(29, 12);
			this->label18->TabIndex = 31;
			this->label18->Text = S"位置";
			// 
			// TB_SPNeedMagicLv2
			// 
			this->TB_SPNeedMagicLv2->Location = System::Drawing::Point(809, 52);
			this->TB_SPNeedMagicLv2->Name = S"TB_SPNeedMagicLv2";
			this->TB_SPNeedMagicLv2->Size = System::Drawing::Size(39, 22);
			this->TB_SPNeedMagicLv2->TabIndex = 30;
			// 
			// label14
			// 
			this->label14->AutoSize = true;
			this->label14->Location = System::Drawing::Point(732, 55);
			this->label14->Name = S"label14";
			this->label14->Size = System::Drawing::Size(77, 12);
			this->label14->TabIndex = 29;
			this->label14->Text = S"需求法術等級";
			// 
			// LB_SPNeedMagicID2
			// 
			this->LB_SPNeedMagicID2->AutoSize = true;
			this->LB_SPNeedMagicID2->Location = System::Drawing::Point(634, 55);
			this->LB_SPNeedMagicID2->Name = S"LB_SPNeedMagicID2";
			this->LB_SPNeedMagicID2->Size = System::Drawing::Size(29, 12);
			this->LB_SPNeedMagicID2->TabIndex = 28;
			this->LB_SPNeedMagicID2->Text = S"名稱";
			// 
			// TB_SPNeedMagicID2
			// 
			this->TB_SPNeedMagicID2->Location = System::Drawing::Point(568, 52);
			this->TB_SPNeedMagicID2->Name = S"TB_SPNeedMagicID2";
			this->TB_SPNeedMagicID2->Size = System::Drawing::Size(60, 22);
			this->TB_SPNeedMagicID2->TabIndex = 27;
			// 
			// label16
			// 
			this->label16->AutoSize = true;
			this->label16->Location = System::Drawing::Point(496, 55);
			this->label16->Name = S"label16";
			this->label16->Size = System::Drawing::Size(65, 12);
			this->label16->TabIndex = 26;
			this->label16->Text = S"需求法術ID";
			// 
			// TB_SPNeedMagicLv1
			// 
			this->TB_SPNeedMagicLv1->Location = System::Drawing::Point(809, 21);
			this->TB_SPNeedMagicLv1->Name = S"TB_SPNeedMagicLv1";
			this->TB_SPNeedMagicLv1->Size = System::Drawing::Size(39, 22);
			this->TB_SPNeedMagicLv1->TabIndex = 25;
			// 
			// label17
			// 
			this->label17->AutoSize = true;
			this->label17->Location = System::Drawing::Point(732, 24);
			this->label17->Name = S"label17";
			this->label17->Size = System::Drawing::Size(77, 12);
			this->label17->TabIndex = 24;
			this->label17->Text = S"需求法術等級";
			// 
			// LB_SPNeedMagicID1
			// 
			this->LB_SPNeedMagicID1->AutoSize = true;
			this->LB_SPNeedMagicID1->Location = System::Drawing::Point(634, 24);
			this->LB_SPNeedMagicID1->Name = S"LB_SPNeedMagicID1";
			this->LB_SPNeedMagicID1->Size = System::Drawing::Size(29, 12);
			this->LB_SPNeedMagicID1->TabIndex = 23;
			this->LB_SPNeedMagicID1->Text = S"名稱";
			// 
			// TB_SPNeedMagicID1
			// 
			this->TB_SPNeedMagicID1->Location = System::Drawing::Point(568, 21);
			this->TB_SPNeedMagicID1->Name = S"TB_SPNeedMagicID1";
			this->TB_SPNeedMagicID1->Size = System::Drawing::Size(60, 22);
			this->TB_SPNeedMagicID1->TabIndex = 22;
			// 
			// label19
			// 
			this->label19->AutoSize = true;
			this->label19->Location = System::Drawing::Point(496, 24);
			this->label19->Name = S"label19";
			this->label19->Size = System::Drawing::Size(65, 12);
			this->label19->TabIndex = 21;
			this->label19->Text = S"需求法術ID";
			// 
			// TB_SPRequestLV
			// 
			this->TB_SPRequestLV->Location = System::Drawing::Point(411, 21);
			this->TB_SPRequestLV->Name = S"TB_SPRequestLV";
			this->TB_SPRequestLV->Size = System::Drawing::Size(39, 22);
			this->TB_SPRequestLV->TabIndex = 10;
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Location = System::Drawing::Point(354, 24);
			this->label5->Name = S"label5";
			this->label5->Size = System::Drawing::Size(53, 12);
			this->label5->TabIndex = 9;
			this->label5->Text = S"需求等級";
			// 
			// LB_SPKeyItemName
			// 
			this->LB_SPKeyItemName->AutoSize = true;
			this->LB_SPKeyItemName->Location = System::Drawing::Point(239, 52);
			this->LB_SPKeyItemName->Name = S"LB_SPKeyItemName";
			this->LB_SPKeyItemName->Size = System::Drawing::Size(29, 12);
			this->LB_SPKeyItemName->TabIndex = 8;
			this->LB_SPKeyItemName->Text = S"名稱";
			// 
			// TB_SPKeyItem
			// 
			this->TB_SPKeyItem->Location = System::Drawing::Point(173, 49);
			this->TB_SPKeyItem->Name = S"TB_SPKeyItem";
			this->TB_SPKeyItem->Size = System::Drawing::Size(60, 22);
			this->TB_SPKeyItem->TabIndex = 7;
			this->TB_SPKeyItem->DoubleClick += new System::EventHandler(this, &LearnMagicForm::SearchKeyItemClick);
			this->TB_SPKeyItem->TextChanged += new System::EventHandler(this, &LearnMagicForm::OnMagicInfoChange);
			// 
			// label7
			// 
			this->label7->AutoSize = true;
			this->label7->Location = System::Drawing::Point(114, 52);
			this->label7->Name = S"label7";
			this->label7->Size = System::Drawing::Size(53, 12);
			this->label7->TabIndex = 6;
			this->label7->Text = S"重要物品";
			// 
			// LB_SPMagicName
			// 
			this->LB_SPMagicName->AutoSize = true;
			this->LB_SPMagicName->Location = System::Drawing::Point(239, 24);
			this->LB_SPMagicName->Name = S"LB_SPMagicName";
			this->LB_SPMagicName->Size = System::Drawing::Size(29, 12);
			this->LB_SPMagicName->TabIndex = 5;
			this->LB_SPMagicName->Text = S"名稱";
			// 
			// TB_SPMagicID
			// 
			this->TB_SPMagicID->Location = System::Drawing::Point(173, 21);
			this->TB_SPMagicID->Name = S"TB_SPMagicID";
			this->TB_SPMagicID->Size = System::Drawing::Size(60, 22);
			this->TB_SPMagicID->TabIndex = 4;
			this->TB_SPMagicID->DoubleClick += new System::EventHandler(this, &LearnMagicForm::SearchMagicClick);
			this->TB_SPMagicID->TextChanged += new System::EventHandler(this, &LearnMagicForm::OnMagicInfoChange);
			// 
			// label10
			// 
			this->label10->AutoSize = true;
			this->label10->Location = System::Drawing::Point(114, 24);
			this->label10->Name = S"label10";
			this->label10->Size = System::Drawing::Size(41, 12);
			this->label10->TabIndex = 3;
			this->label10->Text = S"法術ID";
			// 
			// LV_SPMagic
			// 
			System::Windows::Forms::ColumnHeader* __mcTemp__2[] = new System::Windows::Forms::ColumnHeader*[12];
			__mcTemp__2[0] = this->columnHeader25;
			__mcTemp__2[1] = this->columnHeader6;
			__mcTemp__2[2] = this->columnHeader7;
			__mcTemp__2[3] = this->columnHeader8;
			__mcTemp__2[4] = this->columnHeader9;
			__mcTemp__2[5] = this->columnHeader10;
			__mcTemp__2[6] = this->columnHeader15;
			__mcTemp__2[7] = this->columnHeader21;
			__mcTemp__2[8] = this->columnHeader16;
			__mcTemp__2[9] = this->columnHeader17;
			__mcTemp__2[10] = this->columnHeader22;
			__mcTemp__2[11] = this->columnHeader18;
			this->LV_SPMagic->Columns->AddRange(__mcTemp__2);
			this->LV_SPMagic->FullRowSelect = true;
			this->LV_SPMagic->GridLines = true;
			this->LV_SPMagic->HideSelection = false;
			this->LV_SPMagic->LabelWrap = false;
			this->LV_SPMagic->Location = System::Drawing::Point(6, 146);
			this->LV_SPMagic->MultiSelect = false;
			this->LV_SPMagic->Name = S"LV_SPMagic";
			this->LV_SPMagic->Size = System::Drawing::Size(996, 410);
			this->LV_SPMagic->TabIndex = 20;
			this->LV_SPMagic->UseCompatibleStateImageBehavior = false;
			this->LV_SPMagic->View = System::Windows::Forms::View::Details;
			this->LV_SPMagic->Click += new System::EventHandler(this, &LearnMagicForm::LV_SPMagic_SelectedIndexChanged);
			// 
			// columnHeader25
			// 
			this->columnHeader25->Text = S"位置";
			this->columnHeader25->Width = 42;
			// 
			// columnHeader6
			// 
			this->columnHeader6->Text = S"技能ID";
			// 
			// columnHeader7
			// 
			this->columnHeader7->Text = S"名稱";
			this->columnHeader7->Width = 100;
			// 
			// columnHeader8
			// 
			this->columnHeader8->Text = S"等級";
			this->columnHeader8->Width = 40;
			// 
			// columnHeader9
			// 
			this->columnHeader9->Text = S"重要物品ID";
			this->columnHeader9->Width = 90;
			// 
			// columnHeader10
			// 
			this->columnHeader10->Text = S"物品名稱";
			this->columnHeader10->Width = 90;
			// 
			// columnHeader15
			// 
			this->columnHeader15->Text = S"前置法術ID1";
			this->columnHeader15->Width = 85;
			// 
			// columnHeader21
			// 
			this->columnHeader21->Text = S"法術名稱";
			this->columnHeader21->Width = 85;
			// 
			// columnHeader16
			// 
			this->columnHeader16->Text = S"前置法術LV1";
			this->columnHeader16->Width = 85;
			// 
			// columnHeader17
			// 
			this->columnHeader17->Text = S"前置法術ID2";
			this->columnHeader17->Width = 85;
			// 
			// columnHeader22
			// 
			this->columnHeader22->Text = S"法術名稱";
			this->columnHeader22->Width = 85;
			// 
			// columnHeader18
			// 
			this->columnHeader18->Text = S"前置法術LV2";
			this->columnHeader18->Width = 85;
			// 
			// button12
			// 
			this->button12->Location = System::Drawing::Point(667, 7);
			this->button12->Name = S"button12";
			this->button12->Size = System::Drawing::Size(160, 36);
			this->button12->TabIndex = 27;
			this->button12->Text = S"設定所有技能學習經驗值";
			this->button12->UseVisualStyleBackColor = true;
			this->button12->Visible = false;
			this->button12->Click += new System::EventHandler(this, &LearnMagicForm::SetMagicLearningLvClick);
			// 
			// label9
			// 
			this->label9->AutoSize = true;
			this->label9->ForeColor = System::Drawing::SystemColors::ActiveCaption;
			this->label9->Location = System::Drawing::Point(16, 24);
			this->label9->Name = S"label9";
			this->label9->Size = System::Drawing::Size(29, 12);
			this->label9->TabIndex = 22;
			this->label9->Text = S"職業";
			// 
			// CB_NpcJob
			// 
			this->CB_NpcJob->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->CB_NpcJob->Enabled = false;
			this->CB_NpcJob->ItemHeight = 12;
			this->CB_NpcJob->Location = System::Drawing::Point(64, 16);
			this->CB_NpcJob->Name = S"CB_NpcJob";
			this->CB_NpcJob->Size = System::Drawing::Size(72, 20);
			this->CB_NpcJob->TabIndex = 23;
			this->CB_NpcJob->Tag = S"Vocation";
			// 
			// button1
			// 
			this->button1->Location = System::Drawing::Point(152, 16);
			this->button1->Name = S"button1";
			this->button1->Size = System::Drawing::Size(75, 23);
			this->button1->TabIndex = 26;
			this->button1->Text = S"更新";
			// 
			// LearnMagicForm
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 15);
			this->ClientSize = System::Drawing::Size(1040, 657);
			this->Controls->Add(this->panel1);
			this->Name = S"LearnMagicForm";
			this->Text = S"LearnMagicForm";
			this->panel1->ResumeLayout(false);
			this->panel1->PerformLayout();
			this->tabControl1->ResumeLayout(false);
			this->tabPage1->ResumeLayout(false);
			this->groupBox1->ResumeLayout(false);
			this->groupBox3->ResumeLayout(false);
			this->groupBox3->PerformLayout();
			this->tabPage2->ResumeLayout(false);
			this->groupBox2->ResumeLayout(false);
			this->groupBox4->ResumeLayout(false);
			this->groupBox4->PerformLayout();
			this->ResumeLayout(false);

		}		


#ifndef _Just_Show_DotNet_Form_
    private:
        System::Void GetStr_TextChanged(System::Object *  sender, System::EventArgs *  e);
        System::Void GetValue_ValueChanged(System::Object *  sender, System::EventArgs *  e);
        System::Void ChangeFlag(System::Object *  sender, System::EventArgs *  e);
        System::Void GetIndex_SelectedIndexChanged(System::Object *  sender, System::EventArgs *  e);
        System::Void GetIntValue_TextChanged(System::Object *  sender, System::EventArgs *  e);
        System::Void BaseForm_Closing(System::Object *  sender, System::ComponentModel::CancelEventArgs *  e);
        System::Void SearchObj_DClick(System::Object *  sender, System::EventArgs *  e);
        System::Void SearchMagicClick(System::Object *  sender, System::EventArgs *  e);
        System::Void SearchItemClick(System::Object *  sender, System::EventArgs *  e);
        System::Void SearchWeaponClick(System::Object *  sender, System::EventArgs *  e);
        System::Void SearchArmorClick(System::Object *  sender, System::EventArgs *  e);
        System::Void SearchImageClick(System::Object *  sender, System::EventArgs *  e);
        System::Void SearchRecipeClick(System::Object *  sender, System::EventArgs *  e);
        System::Void SearchKeyItemClick(System::Object *  sender, System::EventArgs *  e);
#endif
        //######################################################################################################
    protected:
        //主要需要繼承的涵式
        virtual ReaderClass< DB_GameObjDbStruct >* ObjReader( );       
        virtual void    OnActive();
        virtual void    OnSelectObj( bool LockOk );
        virtual void    OnOutputObjSetting( DB_GameObjDbStruct* TempObj );
        virtual void    OnTimeProc();
        virtual int     ObjSize();
        virtual void    OnValueChange( ){};
		//更新資料之後的事件
		virtual void	AfterUpdateObj( DB_GameObjDbStruct* TempObj );
        //######################################################################################################
	protected:
		bool	ReSearchNameFlag;

    void RefreshMagicName( );
	System::Void NewNormalMagic_Click(System::Object*  sender, System::EventArgs*  e);
	System::Void DelNormalMagic_Click(System::Object*  sender, System::EventArgs*  e);
	System::Void ModifyNormalMagic_Click(System::Object*  sender, System::EventArgs*  e);
	System::Void LV_NormalMagic_SelectedIndexChanged(System::Object*  sender, System::EventArgs*  e);

	System::Void NewSPMagic_Click(System::Object*  sender, System::EventArgs*  e);
	System::Void DelSPMagic_Click(System::Object*  sender, System::EventArgs*  e);
	System::Void ModifySPMagic_Click(System::Object*  sender, System::EventArgs*  e);
	System::Void LV_SPMagic_SelectedIndexChanged(System::Object*  sender, System::EventArgs*  e);
	System::Void OnMagicInfoChange(System::Object*  sender, System::EventArgs*  e);
	System::Void NormalMagic_UpClick(System::Object*  sender, System::EventArgs*  e);
	System::Void NormalMagic_DownClick(System::Object*  sender, System::EventArgs*  e);
	System::Void SPMagic_UpClick(System::Object*  sender, System::EventArgs*  e);
	System::Void SPMagic_DownClick(System::Object*  sender, System::EventArgs*  e);
	System::Void SetMagicLearningLvClick(System::Object*  sender, System::EventArgs*  e);

private: System::Void groupBox2_Enter(System::Object*  sender, System::EventArgs*  e) {
		 }
};
}